#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "mystruct.h"

VALUES* read_structure(int fd)
{
  VALUES *v = malloc(sizeof(VALUES));

  if(read(fd, v, sizeof(*v)) != sizeof(*v)) {
    perror("Read error");
    exit(-1);
  };

  return v;
}

int write_structure(int fd, VALUES* v)
{
  if(write(fd, v, sizeof(*v)) != sizeof(*v)) {
    perror("Write error");
    exit(-1);
  };

  return(0);
};

int main(int argc, char** argv)
{
  int fd = open("myfile3.out", O_RDWR | O_CREAT, S_IRUSR | S_IWUSR);

  if(fd == -1) {
    perror("Unable to open file");
    exit(-1);
  };

  // Successfully opened file

  int ret = lseek(fd, 16, SEEK_SET);
  printf("Seek: %d\n", ret);

  VALUES v;

  v.a = 5;
  v.b = 3.14159;
  sprintf(v.c, "hello");
  v.d = -1;

  if(write(fd, &v, sizeof(v)) != sizeof(v)) {
    perror("Write error");
    exit(-1);
  };

  /*
  VALUES *v = read_structure(fd);

  printf("%d %f %s %d\n", v->a, v->b, v->c, v->d);
  free(v);
  */

  if(close(fd) != 0) {
    perror("Close error");
    exit(-1);
  }


  return(0);

}
